// Single colour highlight effect
//  Copyright (c) 2013 Open Planet Software. All rights reserved.


varying vec2 texCoordVarying;

uniform sampler2D sourceImage;
uniform vec4 backgroundColour;

void main()
{
    vec4 textureColor = texture2D(sourceImage, texCoordVarying);
    float luminousity = dot( textureColor.xyz, vec3( 0.21, 0.71, 0.07 ) );
    
    vec3 tint = 1.0 - backgroundColour.xyz;
    // Cutoff threshold stored in background alpha channel
    float cutoff = backgroundColour.w;
    
    textureColor.xyz = 1.0 - textureColor.xyz;
    textureColor.xyz *= (1.0 - step( 1.0 - luminousity, cutoff ));
    textureColor.xyz += step( 1.0 - luminousity, cutoff ) * tint;
    textureColor.xyz = 1.0 - textureColor.xyz;

    gl_FragColor = textureColor;
}
